USE [COWS]
GO
_CreateObject 'SP','dbo','GetEncryptData'
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author:		Jagannath Gangi
-- Create date: 06/30/2011
-- Description:	Sets the encrypted value of a decrypted column data
--	sbg9814	09/29/2011	Adding Changes to update Secure Data Accordingly.
-- =============================================
ALTER PROCEDURE [dbo].[GetEncryptData] --'CUST_NME', 96, 'FSA_ORDR_CUST'
(
	@CUST_NME VARCHAR(MAX),
	@CNTCT_LST_NME VARCHAR(MAX),
	@CNTCT_FST_NME VARCHAR(MAX),
	@ADR VARCHAR(MAX),
	@CITY VARCHAR(MAX),
	@STATE VARCHAR(MAX),
	@CNTRY VARCHAR(MAX),
	@PRVNCE VARCHAR(MAX),
	@ZIPCD VARCHAR(MAX),
	@EMAIL VARCHAR(MAX),
	@CUST_PHN VARCHAR(MAX),
	@ONSITE_LST VARCHAR(MAX),
	@ONSITE_FST VARCHAR(MAX),
	@ONSITE_EMAIL VARCHAR(MAX),
	@ORDERID INT
	,@IsSecured	Bit	=	0
) 
AS
BEGIN
BEGIN TRY

	OPEN SYMMETRIC KEY FS@K3y 
	DECRYPTION BY CERTIFICATE S3cFS@CustInf0;
	
	UPDATE dbo.ORDR_ADR WITH (ROWLOCK)
	SET STREET_ADR_1 = CASE COALESCE(@ADR, '') WHEN '' THEN NULL ELSE EncryptByKey(Key_GUID('FS@K3y'), @ADR) END,
	    CTY_NME = CASE COALESCE(@CITY, '') WHEN '' THEN NULL ELSE EncryptByKey(Key_GUID('FS@K3y'), @CITY) END,
	    PRVN_NME = CASE COALESCE(@PRVNCE, '') WHEN '' THEN NULL ELSE EncryptByKey(Key_GUID('FS@K3y'), @PRVNCE) END,
	    STT_CD = CASE COALESCE(@STATE, '') WHEN '' THEN NULL ELSE EncryptByKey(Key_GUID('FS@K3y'), @STATE) END,
	    ZIP_PSTL_CD = CASE COALESCE(@ZIPCD, '') WHEN '' THEN NULL ELSE EncryptByKey(Key_GUID('FS@K3y'), @ZIPCD) END
	WHERE	(ORDR_ID = @ORDERID)	  
		AND	(	(ADR_TYPE_ID	=	2		AND	@IsSecured	=	0)
			OR	(CIS_LVL_TYPE	=	'H1'	AND	@IsSecured	=	1)
			)
	  
	UPDATE dbo.ORDR_CNTCT WITH (ROWLOCK)
	SET LST_NME = CASE COALESCE(@CNTCT_LST_NME, '') WHEN '' THEN NULL ELSE EncryptByKey(Key_GUID('FS@K3y'), @CNTCT_LST_NME) END,
		FRST_NME = CASE COALESCE(@CNTCT_FST_NME, '') WHEN '' THEN NULL ELSE EncryptByKey(Key_GUID('FS@K3y'), @CNTCT_FST_NME) END,
		EMAIL_ADR = CASE COALESCE(@EMAIL, '') WHEN '' THEN NULL ELSE EncryptByKey(Key_GUID('FS@K3y'), @EMAIL) END
	WHERE	(ORDR_ID = @ORDERID)	  
		AND	(	(CNTCT_TYPE_ID	=	1		AND	@IsSecured	=	0)
			OR	(CIS_LVL_TYPE	=	'H1'	AND	@IsSecured	=	1)
			)
	  
	UPDATE dbo.ORDR_CNTCT WITH (ROWLOCK)
	SET LST_NME = CASE COALESCE(@ONSITE_LST, '') WHEN '' THEN NULL ELSE EncryptByKey(Key_GUID('FS@K3y'), @ONSITE_LST) END,
		FRST_NME = CASE COALESCE(@ONSITE_FST, '') WHEN '' THEN NULL ELSE EncryptByKey(Key_GUID('FS@K3y'), @ONSITE_FST) END,
		EMAIL_ADR = CASE COALESCE(@ONSITE_EMAIL, '') WHEN '' THEN NULL ELSE EncryptByKey(Key_GUID('FS@K3y'), @ONSITE_EMAIL) END
	WHERE	(ORDR_ID = @ORDERID)	  
		AND	(	(CNTCT_TYPE_ID	=	4		AND	@IsSecured	=	0)
			OR	(CIS_LVL_TYPE	=	'H1'	AND	@IsSecured	=	1)
			)
			
	UPDATE		dbo.FSA_ORDR_CUST	WITH (ROWLOCK)
		SET		CUST_NME	=	CASE COALESCE(@CUST_NME, '') WHEN '' THEN NULL ELSE EncryptByKey(Key_GUID('FS@K3y'), @CUST_NME) END
		WHERE	ORDR_ID		=	@OrderID
			AND	CIS_LVL_TYPE=	'H1'	
			AND	@IsSecured	=	1
		
 END TRY
 BEGIN CATCH
 EXEC dbo.insertErrorInfo
 END CATCH
END


--select * from SQL_ERROR order by SQL_ERROR_ID desc